/*this file is to declare the functions will be used in configure the UKEY,
*and it include the functions will be used in the PAM.
*the company:cs2c.
*url:www.cs2c.com.cn
*editor:Meng Dewei.
*email:dewei.meng@cs2c.com.cn
*/
#ifndef _UKEY_H_
#define _UKEY_H_

#include <security/pam_appl.h>
#include <security/pam_modules.h>
#include <security/pam_ext.h>

#include <syslog.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <iconv.h>

#include <openssl/x509.h>
#include <openssl/bio.h>
#include <openssl/evp.h>
#include <openssl/pem.h>
#include <openssl/err.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <libintl.h>
#include <locale.h>
#include <pwd.h>
#include <errno.h>
#include <dlfcn.h>

#include "pkcs11/card_help.h"

#define _(string) gettext(string)
#define LOGNAME "PAM-PKCS11"
#define FILE_DIR "/etc/pam_pkcs11_ukey/list/"
#define FILE_DIR_UI	"/etc/pam_pkcs11_ukey/list_UI/"
#define CAFILE "/etc/pam_pkcs11_ukey/ca.crt"
#define SIGLEN 0x14
#define PACKUKEY  "gdm"
#define LOCALEDIR "/usr/share/locale"

/*following functions defined in the ukey.c file.
*/
int IS_UKEY_CONFIG(pam_handle_t *pamh);

int SET_UKEY_CONFIG(pam_handle_t *pamh);

int get(struct pkcs11_struct *cur,char *p);

int openssl_init();

int check_cert_is_expired(X509 *cert);

int is_cert_is_issued_by_CA(X509 *cert);

int check_cert(X509 **cert,char *buffer,int len);

int get_cert(X509 **cert,char *buffer,int len);

int txd_conv(char input);

int txd_decode(unsigned char *inbuf,int *len,unsigned char *outbuf);

int get_user_name(X509 *user_cert,char *username);

int is_spaced_str(const char *str);

int pam_get_pwd(pam_handle_t *pamh,char **pwd);

int init_pkcs11_struct(struct pkcs11_struct *cur);

int free_pkcs11_struct(struct pkcs11_struct *cur,CK_FUNCTION_LIST_PTR pfunctions);

CK_RV pkcs11_login(struct pkcs11_struct *pk,char *passwd,CK_FUNCTION_LIST_PTR pfunctions);

int pkcs11_logout(struct pkcs11_struct *pk,CK_FUNCTION_LIST_PTR pfunctions);

int pkcs11_connect(struct pkcs11_struct *pk,CK_FUNCTION_LIST_PTR functions);

int pkcs11_readcert(struct pkcs11_struct *cur,unsigned char *certdata,int *certlen,CK_FUNCTION_LIST_PTR pfunctions);

int pkcs11_get_private_handle(struct pkcs11_struct *pk,CK_FUNCTION_LIST_PTR pfunctions);

int pkcs11_Sign(struct pkcs11_struct *cur,unsigned char *buf,int len,CK_FUNCTION_LIST_PTR pfunctions);

int encrypt_txt(struct pkcs11_struct *cur,X509 *usercert,char *in,char *str,CK_FUNCTION_LIST_PTR pfunctions);

int str_cat(char *serial,char *username,char *out);

int verify_binded(struct pkcs11_struct *cur,X509 *usercert,char * username);

int auth_by_smartcard(pam_handle_t *pamh,char *password,char *name);

int auth_withbind_by_smartcard(pam_handle_t *pamh,char *password,char *name);

void Export_encrypt_text();


#endif
