#ifndef _H_CARD_HELP_H_
#define _H_CARD_HELP_H_
#include "pkcs11.h"

#define MFFID		0x3f00
#define DFFID		0x5015
#define PKCS11FID	0x4300

#define SKEYKID		(0x84)
#define PINKID		(0x82)

/* AC constants */
#define ALL_AC		(0x9f)
/* SM constants */
#define NONESM		(0x00)
/* EF info */
#define TRANSPARENT	(0x01)
#define NONELOCKED	(0x80)
#define ACTIVEWRITE	(0x40)

#define MAXPIN          16
#define MINPIN          8
#define MODULUS_BIT_LENGTH 1024
struct pkcs11_struct {
        CK_SLOT_ID_PTR m_pSlotList;
        CK_VOID_PTR m_pApplication;
        CK_SESSION_HANDLE m_hSession;
        CK_OBJECT_HANDLE m_hPubKey;
        CK_OBJECT_HANDLE m_hPriKey;
        int m_bKeyGen;
        CK_BYTE m_pSignature[MODULUS_BIT_LENGTH];
        CK_BYTE_PTR m_pbCipherBuffer;
        CK_ULONG m_ulSignatureLen;
        CK_ULONG m_ulCipherLen;
	unsigned char sn[20];
};
#endif
